Package org.zkoss.stateless.sul

## Interface IPortallayout

- All Superinterfaces:
    `IAnyGroup<IPortallayout>`, `IChildable<IPortallayout,​IPortalchildren>`, `IComponent<IPortallayout>`, `IHtmlBasedComponent<IPortallayout>`, `IXulElement<IPortallayout>`

      public interface IPortallayout
      extends IXulElement<IPortallayout>, IChildable<IPortallayout,​IPortalchildren>, IAnyGroup<IPortallayout>

  Immutable `Portallayout` component

  A portal layout lays out a container which can have multiple columns, and each column may contain one or more panel. Portal layout provides a way to drag-and-drop panel into other portalchildren from the same portal layout

  ### Support @Action

  Name | Action Type
  --- | ---
  onPortalDrop | ActionData: `PortalDropData` Represents an action after a portal being dropped and before a portal being moved.

  Author:
    katherine
  See Also:
    `Portallayout`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IPortallayout.Builder` | Builds instances of type `IPortallayout`.
    `static class` | `IPortallayout.MaximizedMode` | Specifies the maximized mode of `IPortallayout` component
    `static class` | `IPortallayout.Orient` | Specifies the orient of `IPortallayout` component
    `static class` | `IPortallayout.Updater` | Builds an updater of type `IPortallayout` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IPortallayout` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getMaximizedMode()` | Returns the mode of the maximized panel.
    `default java.lang.String` | `getOrient()` | Returns the orient.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IPortallayout` | `of​(java.lang.Iterable<? extends IPortalchildren> children)` | Returns the instance with the given `IPortalchildren` children.
    `static IPortallayout` | `of​(IPortalchildren... children)` | Returns the instance with the given `IPortalchildren` children.
    `static IPortallayout` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IPortallayout` | `ofSize​(java.lang.String width, java.lang.String height)` | Returns the instance with the given size, width and height.
    `IPortallayout` | `withMaximizedMode​(java.lang.String maximizedMode)` | Returns a copy of `this` immutable component with the specified `maximizedMode`.
    `default IPortallayout` | `withMaximizedMode​(IPortallayout.MaximizedMode maximizedMode)` | Returns a copy of `this` immutable component with the specified `maximizedMode`.
    `IPortallayout` | `withOrient​(java.lang.String orient)` | Returns a copy of `this` immutable component with the specified `orient`.
    `default IPortallayout` | `withOrient​(IPortallayout.Orient orient)` | Returns a copy of `this` immutable component with the specified `orient`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IPortallayout DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.layout.Portallayout"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IPortallayout>`

    - #### getMaximizedMode

          default java.lang.String getMaximizedMode()

      Returns the mode of the maximized panel.

      Default: `"column"`

    - #### withMaximizedMode

          IPortallayout withMaximizedMode​(java.lang.String maximizedMode)

      Returns a copy of `this` immutable component with the specified `maximizedMode`.

      Sets the mode of the maximized panel

      Parameters:
        `maximizedMode` - The mode of the maximized panel, `"whole"` and `"column"`

        Default: `"column"`.

      Returns:
        A modified copy of the `this` object

    - #### withMaximizedMode

          default IPortallayout withMaximizedMode​(IPortallayout.MaximizedMode maximizedMode)

      Returns a copy of `this` immutable component with the specified `maximizedMode`.

      Sets the mode of the maximized panel

      Parameters:
        `maximizedMode` - The mode of the maximized panel, `"whole"` and `"column"`

        Default: `"column"`.

      Returns:
        A modified copy of the `this` object

    - #### getOrient

          default java.lang.String getOrient()

      Returns the orient.

      Default: `"vertical"`

    - #### withOrient

          IPortallayout withOrient​(java.lang.String orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### withOrient

          default IPortallayout withOrient​(IPortallayout.Orient orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IPortallayout of​(java.lang.Iterable<? extends IPortalchildren> children)

      Returns the instance with the given `IPortalchildren` children.
      Parameters:
        `children` - The children of `IPortalchildren`

    - #### of

          static IPortallayout of​(IPortalchildren... children)

      Returns the instance with the given `IPortalchildren` children.
      Parameters:
        `children` - The children of `IPortalchildren`

    - #### ofSize

          static IPortallayout ofSize​(java.lang.String width,
                                      java.lang.String height)

      Returns the instance with the given size, width and height.
      Parameters:
        `width` - The width of the component
        `height` - The height of the component

    - #### ofId

          static IPortallayout ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component